-- http://sqlblog.com/blogs/adam_machanic/archive/2010/01/12/t-sql-tuesday-002-is-it-xml-or-not.aspx

SET STATISTICS IO, TIME ON;

CREATE TABLE #myXML (
    x VARCHAR(MAX)		-- <-- VARCHAR(MAX) a nie typ XML
)
GO

INSERT #myXML (
    x
)
SELECT
    x
FROM (
    SELECT
        *
    FROM AdventureWorks2014.Production.Product
    FOR XML PATH ('Product')
) AS y (x)
GO -- GO 10

SELECT *
FROM #myXML
;

WITH theXML (x) AS (
	SELECT
		CONVERT(XML, x)		-- <-- konwersja na XML
	FROM #myXML
)
SELECT
    node.value('ProductID[1]', 'INT')
FROM theXML
CROSS APPLY x.nodes('/Product') AS nodes(node)

DECLARE @x XML = (	-- <-- konwersja na XML
	SELECT TOP(1)
		x
	FROM #myXML
)

SELECT
    node.value('ProductID[1]', 'INT')
FROM @x.nodes('/Product') AS nodes(node) 
;

WITH theXML(x) AS
(
    SELECT
        CONVERT(XML, x)
    FROM #myXML
    FOR XML PATH(''), TYPE	-- <-- konwersja na XML
)
SELECT
    node.value('ProductID[1]', 'INT')
FROM theXML
	CROSS APPLY x.nodes('/Product') AS nodes(node)
;

SET STATISTICS IO, TIME OFF;