USE XMLDB_2014;
GO

IF SCHEMA_ID('stg') IS NULL
	EXEC sp_executesql N'CREATE SCHEMA stg AUTHORIZATION dbo';
GO

IF OBJECT_ID(N'stg.wiki', N'U') IS NOT NULL
	DROP TABLE stg.wiki;
GO

CREATE TABLE stg.wiki(
	title		VARCHAR(500)	NULL,
	timestamp	VARCHAR(20)		NULL,
	comment		VARCHAR(1000)	NULL,
	text		VARCHAR(MAX)	NULL
) ON fg_data;
GO

-- to zuzywa 5.3GB tempdb!! (dla TOP 1)
-- bez TOP 1 po 41 minutach przerwanie zasilania, stan: 36 zaimportowanych rekordow
INSERT INTO stg.wiki (title)
SELECT --TOP 1
	T.c.value('title[1]', 'VARCHAR(500)')
FROM (
	SELECT x = CAST(x AS XML)
	FROM OPENROWSET(
		BULK 'S:\\Files\\plwiki-20160407-pages-meta-current1.xml', 
		SINGLE_CLOB
	) r(x)
) x

	CROSS APPLY x.x.nodes('/*:mediawiki/*:page') T(c)


-- podejscie nr 2 - zmienna
-- 2m55s

SET STATISTICS IO, TIME ON;
DECLARE @xmlData XML;

SELECT @xmlData = x.BulkColumn
FROM (
	SELECT BulkColumn
	FROM OPENROWSET(
		BULK 'S:\Files\wiki\plwiki-20160407-pages-meta-current1.xml', 
		SINGLE_CLOB
	) r
) x
;

WITH XMLNAMESPACES (
	'http://www.mediawiki.org/xml/export-0.10/' AS x
)
INSERT INTO stg.wiki (
	title,
	timestamp,
	comment,
	text
)
SELECT
	--T.c.value('namespace-uri(.)', 'VARCHAR(300)'),
	T.c.value('x:title[1]', 'VARCHAR(500)'),
	T.c.value('x:timestamp[1]', 'VARCHAR(500)'),
	T.c.value('x:comment[1]', 'VARCHAR(1000)'),
	T.c.value('x:text[1]', 'VARCHAR(MAX)')
FROM @xmlData.nodes('/x:mediawiki/x:page') T(c)

SET STATISTICS IO, TIME OFF;

-- podejscie nr 3 tabela posrednia (nie w tempdb)
SET STATISTICS IO, TIME ON;
CREATE TABLE xmlData (id INT NOT NULL, xmlData XML);
GO

INSERT INTO xmlData(id, xmlData)
SELECT 1, x.BulkColumn
FROM (
	SELECT BulkColumn
	FROM OPENROWSET(
		BULK 'S:\Files\wiki\plwiki-20160407-pages-meta-current1.xml', 
		SINGLE_CLOB
	) r
) x
;


ALTER TABLE xmlData ADD
	CONSTRAINT PK_id PRIMARY KEY (id)
;
GO

CREATE PRIMARY XML INDEX PXI_ID ON xmlData(xmlData);
GO

SELECT * FROM sys.internal_tables

EXEC sp_help 'sys.xml_index_nodes_661577395_256000'

:CONNECT ADMIN:WIN-R1EPJQ390D6\SQL2014
SELECT COUNT(*)	-- 4 254 981
FROM XMLDB_2014.sys.xml_index_nodes_661577395_256000

SELECT TOP 20 *
FROM XMLDB_2014.sys.xml_index_nodes_661577395_256000


WITH XMLNAMESPACES (
	'http://www.mediawiki.org/xml/export-0.10/' AS x
)
INSERT INTO stg.wiki (
	title,
	timestamp,
	comment,
	text
)
SELECT
	--T.c.value('namespace-uri(.)', 'VARCHAR(300)'),
	T.c.value('x:title[1]', 'VARCHAR(500)'),
	T.c.value('x:timestamp[1]', 'VARCHAR(500)'),
	T.c.value('x:comment[1]', 'VARCHAR(1000)'),
	T.c.value('x:text[1]', 'VARCHAR(MAX)')
FROM xmlData x

	CROSS APPLY x.xmlData.nodes('/x:mediawiki/x:page') T(c)
;

DROP TABLE xmlData;

SET STATISTICS IO, TIME OFF;


SELECT COUNT(*)
FROM stg.wiki WITH (NOLOCK)

SELECT TOP 10 *
FROM stg.wiki WITH (NOLOCK)

CREATE TABLE dbo.wikidata (
	plik	VARCHAR(100),
	dane	XML
)
GO

TRUNCATE TABLE dbo.wikidata
TRUNCATE TABLE stg.wiki

CHECKPOINT

-- 8m7s, 1.5GB
INSERT INTO dbo.wikidata
SELECT 'plik1', *
FROM OPENROWSET(BULK 'F:\plwiki-20160407-pages-meta-current1.xml', SINGLE_CLOB) x(c)

/*
PS C:\temp\sqlxml> Measure-Command {.\load_wiki.ps1}


Days              : 0
Hours             : 0
Minutes           : 11
Seconds           : 54
Milliseconds      : 712
Ticks             : 7147120213
TotalDays         : 0.00827212987615741
TotalHours        : 0.198531117027778
TotalMinutes      : 11.9118670216667
TotalSeconds      : 714.7120213
TotalMilliseconds : 714712.0213
*/

SELECT --c.value('text()[1]', 'VARCHAR(MAX)')
	dane.query('count(//*:text)')
FROM dbo.wikidata

	CROSS APPLY dane.nodes('//*:text') T(c)
