USE XMLDB_2014;
GO

SELECT
	BulkColumn,
	CAST(BulkColumn AS XML)
FROM OPENROWSET(
	BULK 'I:\Files\SampleXML\Sample.xml', 
	SINGLE_BLOB
) AS x



-- import wielu plikow
IF OBJECT_ID(N'u.ProductsXML', N'U') IS NOT NULL
	EXEC sp_executesql N'DROP TABLE u.ProductsXML';
GO

CREATE TABLE u.ProductsXML (
	id			INT			IDENTITY(1, 1)	NOT NULL,
	FileName	CHAR(44)					NULL,
	ProductXML	XML							NOT NULL
);
GO

BEGIN TRANSACTION
DECLARE
	@index		INT	= 1,
	@limit		INT	= 1000,
	@fileName	CHAR(44),
	@sql		NVARCHAR(400)
;

WHILE @index <= @limit
BEGIN

SET
	@fileName	= CONCAT('I:\Files\SampleXML\Products\Product', RIGHT(CONCAT('00000',  @index), 5), '.xml')
;

SET @sql = N'
INSERT INTO u.ProductsXML (FileName, ProductXML)
SELECT
	''' + @fileName + ''',
	x.BulkColumn
FROM OPENROWSET(BULK ''' + @fileName + ''', SINGLE_BLOB) x;
'

EXEC sp_executesql @sql
;

SET @index += 1;

END
COMMIT TRANSACTION

SELECT COUNT(*)
FROM u.ProductsXML