SET STATISTICS IO, TIME ON;

DECLARE @idoc int, @doc xml;

SET @doc = (
SELECT TOP 100
	*
FROM AdventureWorks2014.Sales.SalesOrderDetail
FOR XML PATH ('Detail'), ROOT('Details')
)

--<Details>
--  <Detail>
--    <SalesOrderID>43659</SalesOrderID>
--    <SalesOrderDetailID>1</SalesOrderDetailID>
--    <CarrierTrackingNumber>4911-403C-98</CarrierTrackingNumber>
--    <OrderQty>1</OrderQty>
--    <ProductID>776</ProductID>
--    <SpecialOfferID>1</SpecialOfferID>
--    <UnitPrice>2024.9940</UnitPrice>
--    <UnitPriceDiscount>0.0000</UnitPriceDiscount>
--    <LineTotal>2024.994000</LineTotal>
--    <rowguid>B207C96D-D9E6-402B-8470-2CC176C42283</rowguid>
--    <ModifiedDate>2011-05-31T00:00:00</ModifiedDate>
--  </Detail>
--</Details>

--Create an internal representation of the XML document.
EXEC sp_xml_preparedocument @idoc OUTPUT, @doc;

-- Execute a SELECT statement that uses the OPENXML rowset provider.
SELECT
	*
FROM OPENXML (@idoc, '/Details/Detail', 2)
WITH (
	SalesOrderID		INT,
    SalesOrderDetailID	INT,
	LineTotal			NUMERIC(19, 6)
);

EXEC sp_xml_removedocument @idoc;

SET STATISTICS IO, TIME OFF;