-- ===================================
-- XML - Elements
-- ===================================
-- 5K == 5m, 10K 7m11s, 25K == 12m15s
USE XMLDB_2014;
GO

DECLARE
	@index		INT	= 1,
	@limit		INT	= 25000,	-- 4242
	@xmlData	XML,
	@fileName	VARCHAR(50)
;

WHILE @index <= @limit
BEGIN

SELECT
	@fileName	= CONCAT('S:\Files\SampleXML\Products\Product', RIGHT(CONCAT('00000',  @index), 5), '.xml'),
	@xmlData	= (
		SELECT *
		FROM AdventureWorks2014.dbo.bigProduct
		WHERE
			1 = 1
		ORDER BY
			ProductId
		OFFSET @index ROWS FETCH NEXT 1 ROW ONLY
		FOR XML RAW, ELEMENTS
	)

--SELECT @xmlData

SET @index += 1;

EXECUTE dbo.spSaveXMLVariableToFile @xmlData, @fileName;

END

-- ===================================
-- XML - Attributes
-- ===================================

USE XMLDB_2014;
GO

DECLARE
	@index		INT	= 1,
	@limit		INT	= 1000,	-- 4242
	@xmlData	XML,
	@fileName	VARCHAR(50)
;

WHILE @index <= @limit
BEGIN

SELECT
	@fileName	= CONCAT('S:\Files\SampleXML\Products\Product', RIGHT(CONCAT('0000',  @index), 4), '.xml'),
	@xmlData	= (
		SELECT *
		FROM AdventureWorks2014.dbo.bigProduct
		WHERE
			1 = 1
		ORDER BY
			ProductId
		OFFSET @index ROWS FETCH NEXT 1 ROW ONLY
		FOR XML RAW
	)

--SELECT @xmlData

SET @index += 1;

EXECUTE dbo.spSaveXMLVariableToFile @xmlData, @fileName;

END