USE XMLDB_2014;
GO

-- typed XML
IF OBJECT_ID(N't.ProductsXML', N'U') IS NOT NULL
	EXEC sp_executesql N'DROP TABLE t.ProductsXML';
GO

CREATE TABLE t.ProductsXML (
	id			INT			IDENTITY(1, 1)	NOT NULL,
	FileName	CHAR(44)					NULL,
	ProductXML	XML(Product)				NOT NULL
);
GO

BEGIN TRANSACTION
DECLARE
	@index		INT	= 1,
	@limit		INT	= 25000,
	@fileName	CHAR(44),
	@sql		NVARCHAR(400)
;

WHILE @index <= @limit
BEGIN

SET
	@fileName	= CONCAT('S:\Files\SampleXML\Products\Product', RIGHT(CONCAT('00000',  @index), 5), '.xml')
;

SET @sql = N'
INSERT INTO t.ProductsXML (FileName, ProductXML)
SELECT
	''' + @fileName + ''',
	x.BulkColumn
FROM OPENROWSET(BULK ''' + @fileName + ''', SINGLE_BLOB) x;
'

EXEC sp_executesql @sql
;

SET @index += 1;

END
COMMIT TRANSACTION

/*
SELECT COUNT(*)
FROM t.ProductsXML WITH (NOLOCK)

SELECT COUNT(*)
FROM u.ProductsXML WITH (NOLOCK)
*/