-- CREATE/TRUNCATE TABLES

USE XMLDB_2014
GO

CREATE TABLE wiki.contributor (
	[username] [nvarchar](255) NULL,
	[id] [bigint] NULL,
	[revision_Id] [numeric](20, 0) NULL
) ON [FG_DATA]
;
GO

USE [XMLDB_2014]
GO

/****** Object:  Table [dbo].[namespace]    Script Date: 5/12/2016 3:22:17 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE wiki.namespace (
	[key] [smallint] NULL,
	[case] [nvarchar](255) NULL,
	[text] [nvarchar](255) NULL,
	[namespaces_Id] [numeric](20, 0) NULL
) ON [FG_DATA]

GO

USE [XMLDB_2014]
GO

/****** Object:  Table [dbo].[namespaces]    Script Date: 5/12/2016 3:22:24 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE wiki.namespaces (
	[namespaces_Id] [numeric](20, 0) NULL,
	[siteinfo_Id] [numeric](20, 0) NULL
) ON [FG_DATA]

GO

USE [XMLDB_2014]
GO

/****** Object:  Table [dbo].[page]    Script Date: 5/12/2016 3:22:32 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE wiki.page (
	[page_Id] [numeric](20, 0) NULL,
	[title] [nvarchar](255) NULL,
	[ns] [tinyint] NULL,
	[id] [int] NULL
) ON [FG_DATA]

GO

USE [XMLDB_2014]
GO

/****** Object:  Table [dbo].[revision]    Script Date: 5/12/2016 3:22:40 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE wiki.revision (
	[revision_Id] [numeric](20, 0) NULL,
	[id] [bigint] NULL,
	[parentid] [bigint] NULL,
	[timestamp] [datetime] NULL,
	[minor] [nvarchar](255) NULL,
	[comment] [nvarchar](255) NULL,
	[model] [nvarchar](255) NULL,
	[format] [nvarchar](255) NULL,
	[sha1] [nvarchar](255) NULL,
	[page_Id] [numeric](20, 0) NULL
) ON [FG_DATA]

GO

USE [XMLDB_2014]
GO

/****** Object:  Table [dbo].[siteinfo]    Script Date: 5/12/2016 3:22:48 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE wiki.siteinfo (
	[siteinfo_Id] [numeric](20, 0) NULL,
	[sitename] [nvarchar](255) NULL,
	[dbname] [nvarchar](255) NULL,
	[base] [nvarchar](255) NULL,
	[generator] [nvarchar](255) NULL,
	[case] [nvarchar](255) NULL
) ON [FG_DATA]

GO

USE [XMLDB_2014]
GO

/****** Object:  Table [dbo].[text]    Script Date: 5/12/2016 3:22:55 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE wiki.text (
	[space] [nvarchar](255) NULL,
	[text] [nvarchar](max) NULL,
	[revision_Id] [numeric](20, 0) NULL
) ON [FG_DATA] TEXTIMAGE_ON [FG_DATA]

GO




TRUNCATE TABLE wiki.contributor;
TRUNCATE TABLE wiki.namespace;
TRUNCATE TABLE wiki.namespaces;
TRUNCATE TABLE wiki.page;
TRUNCATE TABLE wiki.revision;
TRUNCATE TABLE wiki.siteinfo;
TRUNCATE TABLE wiki.text;