USE XMLDB_2014;
GO

DECLARE @xmlSchema	VARCHAR(MAX)	-- VARCHAR not NVARCHAR --> tnight_xsd == <?xml version="1.0" encoding="windows-1250"?>
;

SELECT
	@xmlSchema	= xmlCol
FROM OPENROWSET(BULK 'C:\temp\t_night.xsd', SINGLE_CLOB) res(xmlCol)
;

SELECT @xmlSchema;

CREATE XML SCHEMA COLLECTION shakespeare AS @xmlSchema;
GO

--DROP TABLE shakespeare_untyped;

CREATE TABLE shakespeare_untyped (
	id			INT				IDENTITY(1, 1),
	name		VARCHAR(50)		NOT NULL,
	content		XML				NOT NULL,

	CONSTRAINT PK_su_id PRIMARY KEY (id)
);
GO

-- before import remove <!DOCTYPE PLAY SYSTEM "play.dtd"> from file
INSERT INTO shakespeare_untyped (name, content)
SELECT
	'Twelfth Night, or What You Will',
	xmlCol
FROM OPENROWSET(BULK 'C:\\temp\\t_night.xml', SINGLE_CLOB) res(xmlCol)
;

SELECT *
FROM shakespeare_untyped;

-- ========================
--DROP TABLE shakespeare_typed;

CREATE TABLE shakespeare_typed (
	id			INT					IDENTITY(1, 1),
	name		VARCHAR(50)			NOT NULL,
	content		XML(shakespeare)	NOT NULL,

	CONSTRAINT PK_st_id PRIMARY KEY (id)
);
GO

-- before import remove <!DOCTYPE PLAY SYSTEM "play.dtd"> from file
INSERT INTO shakespeare_typed (name, content)
SELECT
	'Twelfth Night, or What You Will',
	xmlCol
FROM OPENROWSET(BULK 'C:\\temp\\t_night.xml', SINGLE_CLOB) res(xmlCol)
;

SELECT *
FROM shakespeare_typed;

--

SELECT
	content.query('count(//LINE)')
FROM shakespeare_typed;

SELECT
	content.query('count(//LINE)')
FROM shakespeare_untyped;

CREATE PRIMARY XML INDEX sht
	ON shakespeare_typed(content)
;

CREATE PRIMARY XML INDEX shu
	ON shakespeare_untyped(content)
;