USE XMLDB_2014;
GO

-- untyped XML
IF OBJECT_ID(N'u.ProductsXML', N'U') IS NOT NULL
	EXEC sp_executesql N'DROP TABLE u.ProductsXML';
GO

CREATE TABLE u.ProductsXML (
	id			INT			IDENTITY(1, 1)	NOT NULL,
	FileName	CHAR(44)					NULL,
	ProductXML	XML							NOT NULL
);
GO

INSERT INTO u.ProductsXML (ProductXML)
SELECT
	x.BulkColumn
FROM OPENROWSET(
	BULK 'S:\Files\SampleXML\Products\Product0002.xml', 
	SINGLE_BLOB) x;

INSERT INTO u.ProductsXML (ProductXML)
SELECT
	x.BulkColumn
FROM OPENROWSET(BULK 'S:\Files\SampleXML\Products\Product0002.xml', SINGLE_NCLOB) x;

INSERT INTO u.ProductsXML (ProductXML)
SELECT
	x.BulkColumn
FROM OPENROWSET(
	BULK 'S:\Files\SampleXML\Products\Product0002.xml', 
	SINGLE_BLOB
) x;


-- zasilamy pliki
BEGIN TRANSACTION
DECLARE
	@index		INT	= 1,
	@limit		INT	= 1000,
	@fileName	CHAR(44),
	@sql		NVARCHAR(400)
;

WHILE @index <= @limit
BEGIN

SET
	@fileName	= CONCAT('S:\Files\SampleXML\Products\Product', RIGHT(CONCAT('0000',  @index), 4), '.xml')
;

SET @sql = N'
INSERT INTO u.ProductsXML (FileName, ProductXML)
SELECT
	''' + @fileName + ''',
	x.BulkColumn
FROM OPENROWSET(BULK ''' + @fileName + ''', SINGLE_BLOB) x;
'

EXEC sp_executesql @sql
;

SET @index += 1;

END

COMMIT TRANSACTION


-- ===========================
USE XMLDB_2014;
GO

-- DROP XML SCHEMA COLLECTION Product

-- XML SCHEMA
DECLARE @xmlSchema	XML
;

SELECT
	@xmlSchema	= xmlCol
FROM OPENROWSET(BULK 'S:\Files\SampleXML\Product.xsd', SINGLE_BLOB) res(xmlCol)
;

SELECT @xmlSchema;

CREATE XML SCHEMA COLLECTION Product AS @xmlSchema;
GO

-- typed XML
IF OBJECT_ID(N't.ProductsXML', N'U') IS NOT NULL
	EXEC sp_executesql N'DROP TABLE t.ProductsXML';
GO

CREATE TABLE t.ProductsXML (
	id			INT			IDENTITY(1, 1)	NOT NULL,
	FileName	CHAR(44)					NULL,
	ProductXML	XML(Product)				NOT NULL
);
GO