--https://ask.sqlservercentral.com/questions/7158/output-sql-data-as-xml-and-export-to-xml-file.html

IF OBJECT_ID (N'dbo.spSaveXMLVariableToFile') IS NOT NULL
	DROP PROCEDURE dbo.spSaveXMLVariableToFile
GO

CREATE PROCEDURE dbo.spSaveXMLVariableToFile
   @TheXML XML,
   @Filename VARCHAR(255)
AS
SET NOCOUNT ON
DECLARE @MySpecialTempTable VARCHAR(255)
DECLARE @Command NVARCHAR(4000)
DECLARE @RESULT INT
 
--firstly we create a global temp table with a unique name
SELECT  @MySpecialTempTable = '##temp'
    + CONVERT(VARCHAR(12), CONVERT(INT, RAND() * 1000000))
--then we create it using dynamic SQL, & insert a single row
--in it with the variable stocked with the XML we want
SELECT  @Command = 'create table ['
    + @MySpecialTempTable
    + '] (MyID int identity(1,1), Bulkcol XML)
 insert into ['
    + @MySpecialTempTable
    + '](BulkCol) select @TheXML'
EXECUTE sp_ExecuteSQL @command, N'@TheXML XML',
        @TheXML
 
--then we execute the BCP to save the file
SELECT  @Command = 'bcp "select BulkCol from ['
        + @MySpecialTempTable + ']'
        + '" queryout '
        + @Filename + ' '
        + '-w'--save as unicode
        + ' -T -S' + @@servername
EXECUTE @RESULT= MASTER..xp_cmdshell @command, NO_OUTPUT
EXECUTE ( 'Drop table ' + @MySpecialTempTable )
RETURN @result
GO 

-- test generic procedure
--we write it out to a unicode file

DECLARE @testXML XML = (SELECT
        *
    FROM AdventureWorks2014.Production.Product
    FOR XML PATH ('Product'))
EXECUTE dbo.spSaveXMLVariableToFile @testXML, 'S:\Files\SampleXML\Sample.xml'
GO


--and read it back in again!    
SELECT CONVERT(nVARCHAR(max),BulkColumn)
FROM    OPENROWSET(BULK 'S:\Files\SampleXML\Sample.xml', SINGLE_BLOB) AS x 

