$instanceName = "WIN-R1EPJQ390D6\SQL2014"
$databaseName = "XMLDB_2014"

#truncate table
Invoke-Sqlcmd -ServerInstance $instanceName -Database $databaseName -Query "TRUNCATE TABLE u.ProductsXML"

#get all XML files
$xmlfiles = Get-ChildItem "I:\Files\SampleXML\Products" -Filter "*.xml"
 
#upload each file to SQL Server
foreach($xmlfile in $xmlfiles)
{
    #need to replace illegal characters
    #Write-Host "Importing " $xmlfile.FullName "..."
    [string]$xml = (Get-Content $xmlfile.FullName) -replace "'", "''"
 
#note we're using HERETO string;
$query = @"
INSERT INTO u.ProductsXML (FileName, ProductXML) 
VALUES('$xmlfile', '$xml')
"@
 
    #insert into SQL Server
    Invoke-Sqlcmd -ServerInstance $instanceName -Database $databaseName -Query $query
}
 <#
#display our results
#how many records have been inserted?
$query = @"
SELECT COUNT(*) AS num
FROM u.ProductsXML 
"@
 
$result = Invoke-Sqlcmd -ServerInstance $instanceName -Database $databaseName -Query $query
Write-Host "Inserted " $result.num " records in the table"
#>

#Measure-Command {.\LoadProductsUntyped.ps1}