$instanceName = "WIN-R1EPJQ390D6\SQL2014"
$databaseName = "XMLDB_2014"

#create our test table
$prepfile = "S:\Scripts\PowerShellStuff.Table.sql"
Invoke-Sqlcmd -ServerInstance $instanceName -Database $databaseName -InputFile $prepfile
 
#get all XML files
$xmlfiles = Get-ChildItem "S:\Files\shakespeare" -Filter "*.xml"
 
#upload each file to SQL Server
foreach($xmlfile in $xmlfiles)
{
    #need to replace illegal characters
    Write-Host "Importing " $xmlfile.FullName "..."
    [string]$xml = (Get-Content $xmlfile.FullName) -replace "'", "''"
 
#note we're using HERETO string; CONVERT - bo jest wewnetrzny DTD
$query = @"
INSERT INTO PowerShellStuff(FileName,XMLStuff) 
VALUES('$xmlfile',CONVERT(XML, '$xml', 2))
"@
 
    #insert into SQL Server
    Invoke-Sqlcmd -ServerInstance $instanceName -Database $databaseName -Query $query
}
 
#display our results
#how many records have been inserted?
$query = @"
SELECT COUNT(*) AS num
FROM PowerShellStuff 
"@
 
$result = Invoke-Sqlcmd -ServerInstance $instanceName -Database $databaseName -Query $query
Write-Host "Inserted " $result.num " records in the table"

#Measure-Command {.\LoadShakeSpeare.ps1}